<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" ValidateRequest="false" Inherits="GcPdfViewerSupportApiDemo._Default" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">
<link href="https://cdn.materialdesignicons.com/5.0.45/css/materialdesignicons.min.css" rel="stylesheet">
<style>
    html, body, body > form, .body-content {
        height: 100%;
        width: 100%;
    }
    #host {
        padding: 60px 20px 20px 10px;
    }
@media (max-width:500px) {
    #host {
        padding: 50px 0px 0px 0px;
    }
    .body-content {
        padding-left: 0px;
        padding-right: 0px;
    }
}
</style>

<div id="host"></div>
<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
<script src="scripts/lib/pdfviewer/build/gcpdfviewer.js?ts=20230407-01"></script>
<script id="js-sample-code">

var viewer;
var React;
function findBaseUrl(options) {  
  var s = window.__baseUrl || ((options.supportApi || {}).apiUrl || '');
  return s[s.length - 1] !== '/' ? s + '/' : s; 
}
function createPdfViewer(selector, baseOptions) {
  // Prepare viewer options:
  var options = baseOptions || {};
  if(!options.supportApi) {
      options.supportApi = {
          apiUrl: (window.__baseUrl || '') + 'support-api/gc-pdf-viewer',
          token: window.afToken || '',
          webSocketUrl: false, 
          suppressInfoMessages: true, 
          suppressErrorMessages: true
      };
  }
  // Arbitrary data associated with the viewer. 
  // This data is sent to the server when the document is saved:        
  options.userData = { sampleName: 'SaveChangesSample', docName: new Date().getTime() + '.pdf' };
  // Create viewer instance:
  viewer = new GcPdfViewer(selector, options);
  // Add annotation editor:
  viewer.addAnnotationEditorPanel();
  // Create custom 'Save changes' button
  React = viewer.getType('React');
  viewer.toolbar.addItem({ 
    key: 'custom-save', 
    icon: { type: 'svg', content: React.createElement('svg', { xmlns: 'http://www.w3.org/2000/svg', version: '1.1', width: '24', height: '24', viewBox: '0 0 24 24', fill: '#ff0000' }, React.createElement('path', { d: 'M20.913 9.058c0.057-0.26 0.087-0.531 0.087-0.808 0-2.071-1.679-3.75-3.75-3.75-0.333 0-0.657 0.044-0.964 0.125-0.581-1.813-2.28-3.125-4.286-3.125-2.047 0-3.775 1.367-4.32 3.238-0.533-0.155-1.097-0.238-1.68-0.238-3.314 0-6 2.686-6 6s2.686 6 6 6h3v4.5h6v-4.5h5.25c2.071 0 3.75-1.679 3.75-3.75 0-1.845-1.333-3.379-3.087-3.692zM13.5 15v4.5h-3v-4.5h-3.75l5.25-5.25 5.25 5.25h-3.75z' })) }, 
    title: 'Save document',
    enabled: false,
    action: function() {
        // Save changes on server:
        viewer.saveChanges().then(function(result) {
            if(result) {
                var docUrl = findBaseUrl(options) + 'GetPdfFromCloud?docName=' + options.userData.docName + '&clientId=' + viewer.supportApi.clientId;
                viewer.open(docUrl).then(function() {
                    alert('The document is saved in the cloud. The service life of the document is 10 minutes.');
                });
            }
        });
    },
    onUpdate: function() {
        return {
            enabled: viewer.hasDocument,
            title: 'Save changes'
        };
    }
  });
  viewer.toolbarLayout.viewer.default.splice(0, 0, 'download');
  // Insert 'custom-save' item into viewer toolbar layout:
  viewer.toolbarLayout.viewer.default.splice(0, 0, 'custom-save');
  // Change annotationEditor toolbar layout:
  var annotationEditorButtons = ['custom-save', 'download', 'edit-select', 'edit-sign-tool', '$split', 'edit-text', 'edit-free-text', 'edit-ink', 'edit-square',
        'edit-circle', 'edit-line', 'edit-polyline', 'edit-polygon', 'edit-stamp', 'edit-link',
        '$split', 'edit-redact', 'edit-redact-apply', 'edit-erase', '$split', 'new-document', '$split', 'new-page', 'delete-page'];
  viewer.toolbarLayout.annotationEditor = { default: annotationEditorButtons, mobile: annotationEditorButtons, fullscreen: annotationEditorButtons };
  return viewer;
}
    function getHashValue(key) { var matches = location.hash.match(new RegExp(key + '=([^&]*)')); return matches ? matches[1] : null; }
    var viewer;
    var options = {
        workerSrc: 'scripts/lib/pdfviewer/build/gcpdfviewer.worker.js',
        supportApi: {
            apiUrl: '/CustomSupportApi',
            token: 'support-api-demo-token',
            legacyServer: true
        },
        userName: getHashValue('user') || 'Anonymous',
        documentListUrl: '/CustomSupportApi/DocumentList',
        logLevel: 'Debug'
    };
    if (window.createPdfViewer) {
        viewer = window.createPdfViewer('#host', options);
    } else {
        if (options.userName === "Anonymous") {
            options.userName = prompt("Please, input your name", options.userName) || "Anonymous";
        }
        viewer = new GcPdfViewer("#host", options);
        viewer.addDefaultPanels();
        viewer.addFormEditorPanel();
        viewer.addAnnotationEditorPanel();
        //viewer.addDocumentListPanel();
        viewer.addSharedDocumentsPanel();
        <%=(GcPdfViewerSupportApiDemo.Utils.GcPdfViewerRenderHelper.RenderOptions(GcPdfViewerSupportApiDemo.Samples.SamplePdfCreator.GetViewerOptions()))%>
        viewer.beforeUnloadConfirmation = true;        
    }
    if(viewer.then) {
        viewer.then(function(resolvedViewer) { 
            viewer = resolvedViewer;
            viewer.open("/CustomSupportApi/GetSamplePdf"); 
        });
    } else {
        viewer.open("/CustomSupportApi/GetSamplePdf");
    }
    // Viewer opened.
</script>

</asp:Content>
